' ,      ""
'     
'   bin\config\scripts

'   " ".
'        1.
'    ,    .
' name -   .
' text -   .   .
' cancel -  .    True   .
'
Sub Telepat_OnTemplate(Name, Text, Cancel)
    '      
    ' c    
    If Name = " " Then
        Text = "// " & Trim(CStr(Now()))
    ElseIf Name = " " Then
        Cancel = FillDoc(Text)
    ElseIf Name = " " Then
        Cancel = FillTablePart(Text)
    ElseIf Name = " " Then
        Cancel = FillDocRegister(Text)
    End If
End Sub

'   
Function FillDoc(Text)
    FillDoc = True      '     
    '     
    DocKind = ""
    Set MetaDoc = SelectMetaObj(DocKind, "", "  ")
    If MetaDoc Is Nothing Then Exit Function    '   

    '   ,   
    docName = InputBox("   ", " ", "" & DocKind)
    If Len(docName) = 0 Then Exit Function
    FillDoc = False '     

    '      
    Text = Replace(Text, "!selDoc!", DocKind)
    '      
    Text = Replace(Text, "!selVar!", docName)
    
    '     
    Set Head = MetaDoc.Childs("")
    Set Table = MetaDoc.Childs("")
    Set CommonRekv = MetaData.TaskDef.Childs("")
    '      
    '   
    ReDim Lines(2 + CommonRekv.Count + Head.Count + Table.Count)
    
    docName = docName & "."
   
    iCurLine = 0        '   
    '    
    FillNamesLines "//  ", docName, CommonRekv, Lines, iCurLine
    '   
    FillNamesLines "//  ", docName, Head, Lines, iCurLine
    '   
    FillNamesLines "//   ", docName, Table, Lines, iCurLine
    '     
    Text = Text & Join(Lines, vbCrLf)
End Function

'     
'    . = .;
Function FillTablePart(Text)
    FillTablePart = True    '     
    '     
    DocKind = ""
    Set MetaDoc = SelectMetaObj(DocKind, "", "  ")
    If MetaDoc Is Nothing Then Exit Function
    '  MetaArray c     
    Set Table = MetaDoc.Childs("")
    iCountLines = Table.Count
    If iCountLines = 0 Then
        MsgBox "  """ & DocKind & """   ", , ""
        Exit Function
    End If
    
    '      
    selFrom = InputBox(",   ", " ", "")
    If Len(selFrom) = 0 Then Exit Function
    '      
    selTo = InputBox(",   ", " ", "")
    If Len(selTo) = 0 Then Exit Function
    
    FillTablePart = False   '   .   
    '      
    Text = Replace(Text, "!selFrom!", selFrom)
    '      
    ReDim Lines(iCountLines - 1)
    selTo = vbTab & selTo & "."
    iMaxNameLen = MaxNameLen(Table, 0) + Len(selTo)
    selFrom = " = " & selFrom & "."
    For i = 0 To iCountLines - 1
        Lines(i) = selTo & Table(i).Name
        Lines(i) = Lines(i) & Space(iMaxNameLen - Len(Lines(i))) & selFrom & Table(i).Name & ";"
    Next
    '      
    Text = Replace(Text, "!dynamic_part!", Join(Lines, vbCrLf))
End Function

'   " "
Function FillDocRegister(Text)
    FillDocRegister = True  '     
    '     
    RegName = ""
    Set MetaReg = SelectMetaObj(RegName, "", "  ")
    If MetaReg Is Nothing Then Exit Function
    
    ' ,   
    Set TextDoc = Windows.ActiveWnd.Document
    If TextDoc = docWorkBook Then Set TextDoc = TextDoc.Page(1)
    docVarName = ""
    If TextDoc.Kind <> "Transact" Then
        '       ,
        '     
        docVarName = InputBox("   ", " ", "")
        If Len(docVarName) > 0 Then docVarName = docVarName & "."
    End If
    '        
    regVarName = InputBox("   ", " ", "" & RegName)
    If Len(regVarName) = 0 Then Exit Function
    '   ,   
    FillDocRegister = False
    '     
    Text = Replace(Text, "!regVar!", regVarName)
    Text = Replace(Text, "!docVar!", docVarName)
    Text = Replace(Text, "!regName!", RegName)
    '    
    Set Fields = MetaReg.Childs("")
    Set Resurs = MetaReg.Childs("")
    Set Rekv = MetaReg.Childs("")

    '    
    ReDim Lines(2 + Fields.Count + Resurs.Count + Rekv.Count)

    regVarName = vbTab & regVarName & "."
    
    iCurLine = 0        '   
    '  
    FillNamesLines vbTab & "//   " & RegName, regVarName, Fields, Lines, iCurLine
    '  
    FillNamesLines vbTab & "//   " & RegName, regVarName, Rekv, Lines, iCurLine
    '  
    FillNamesLines vbTab & "//   " & RegName, regVarName, Resurs, Lines, iCurLine
    '     
    Text = Replace(Text, "!dynamic_part!", Join(Lines, vbCrLf))
End Function

'    1   
Function SelectMetaObj(objName, objType, Title)
    '      ConvertTemplate
    '     
    '    1-
    '    
    '        
    '      ,
    '  <?" ",>
    objName = Telepat.ConvertTemplate("<?""" & Title & """," & objType & ">")
    If Len(objName) = 0 Then Set SelectMetaObj = Nothing: Exit Function
    '      
    Set SelectMetaObj = MetaData.TaskDef.Childs(CStr(objType))(CStr(objName))
End Function

'     
'   .     =
Function MaxNameLen(MetaArray, OldMaxLen)
    MaxNameLen = OldMaxLen
    For i = 0 To MetaArray.Count - 1
        If Len(MetaArray(i).Name) > MaxNameLen Then MaxNameLen = Len(MetaArray(i).Name)
    Next
End Function

'    ,  ,
'  
' LeftPart  = ; //  
'    =
Sub FillNamesLines(Title, LeftPart, MetaRekvArray, Lines(), iCurLine)
    iMaxNameLen = MaxNameLen(MetaRekvArray, 0) + Len(LeftPart)
    Lines(iCurLine) = Title
    iCurLine = iCurLine + 1
    For i = 0 To MetaRekvArray.Count - 1
        Line = LeftPart & MetaRekvArray(i).Name
        Line = Line & Space(iMaxNameLen - Len(Line)) & " = ;"
        Descr = MetaRekvArray(i).Descr
        If Len(Descr) > 0 Then
            If Descr <> MetaRekvArray(i).Name Then
                Line = Line & " // " & Descr
            End If
        End If
        Lines(iCurLine) = Line
        iCurLine = iCurLine + 1
    Next
End Sub

'  . param -  ,
'     
'
Sub Init(param)
    Set t = Plugins("")  '  
    If Not t Is Nothing Then    '  "" 
        '     
        SelfScript.AddNamedItem "Telepat", t, False
        '      Telepat
        '   
        '   
        'Telepat.Components = 1 + 2 + 4                  '  . 1-, 2 - , 4 - 
        'Telepat.Language = 1 + 2                        '  . 1- , 2 - 
        'Telepat.UseStdMethodDlg = False                 '    " "
        'Telepat.NoOrderMethodDlg = False                '      " "
        'Telepat.FilterMethodDlg = True                  '     " "
        'Telepat.AutoParamInfo = True                    '    
        'Telepat.ParamInfoAddMethDescr = True            '       
        'Telepat.ParamInfoAddParamDescr = True           '       
        'Telepat.AutoActiveCountSymbols = 2              '      
        'Telepat.DisableTemplateInRemString = True       '      
    Else
        '   .   
        Scripts.Unload SelfScript.Name
    End If
End Sub

'     
Init 0
